; ##############################################################################
; ##############################################################################
; ##############################################################################
ENC_WAIT_CLKRDY:
	; ESTAT.CLKRDY	
	ldi temp1,(ESTAT)
	rcall ENC_SPI_READ_CONTROL_REGISTER_TEMP1
	andi temp1,0b00000011
	cpi  temp1,0b00000001
	brne ENC_WAIT_CLKRDY_ERROR
	ret
;-------------------------------------------------------------------------------
ENC_WAIT_CLKRDY_ERROR:
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	call WAIT_50ms
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus  
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	call WAIT_50ms
rjmp ENC_WAIT_CLKRDY
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Reset ber SPI																
ENC_SOFT_RESET:
	call SPI_CS_LOW							; CS auf LOW	
	ldi temp1,(Enc28j60_soft_reset)				; RESET			
	call SPI_TX_TEMP1							; TX			
	sbi (SPI_CS_PORT),(SPI_CS_PIN_NR)			; CS auf HIGH	
	call WAIT_100ms
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 11x = Reserved for factory test. Do not use. Glitch prevention not assured.	
;*101 = CLKOUT outputs main clock divided by 8 (3.125 MHz)						
; 100 = CLKOUT outputs main clock divided by 4 (6.25 MHz)						
; 011 = CLKOUT outputs main clock divided by 3 (8.333333 MHz)					
; 010 = CLKOUT outputs main clock divided by 2 (12.5 MHz)						
; 001 = CLKOUT outputs main clock divided by 1 (25 MHz)							
; 000 = CLKOUT is disabled. The pin is driven low.								
ENC_CLKOUT_PIN:
	; ECOCON
	ldi temp1,(ECOCON)
	ldi temp2,(0<<ECOCON_COCON2)|(0<<ECOCON_COCON1)|(0<<ECOCON_COCON0)
	rcall ENC_SPI_WRITE_CONTROL_REGISTER_TEMP1_TEMP2	; INP: temp1(cod+addr) temp2(data)		
	rcall ENC_SPI_WRITE_CONTROL_REGISTER_CHECK_TEMP1_TEMP2 	; INP: temp1(cod+addr) temp2(data)		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ENC_LED_BLINKEN_ON:
	ldi temp1,(PHLCON)
	ldi temp2,LOW (0x0AA2)
	ldi temp3,HIGH(0x0AA2)
	rcall ENC_SPI_WRITE_PHY_REGISTER_TEMP1_TEMP2_TEMP3; INP: temp1(phy.addr) temp2(data) temp3(data)	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ENC_LED_BLINKEN_OFF:
	ldi temp1,(PHLCON)
	ldi temp2,LOW (0x3422); 0011 0100 0010 001x
	ldi temp3,HIGH(0x3422)
	rcall ENC_SPI_WRITE_PHY_REGISTER_TEMP1_TEMP2_TEMP3; INP: temp1(phy.addr) temp2(data) temp3(data)	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ENC_MAC_ADRESSE_SET:
	; MAC-Adresse				
	ldi temp1,(MAADR1)
	ldi temp2,(MAC1)
	rcall ENC_SPI_WRITE_CONTROL_REGISTER_TEMP1_TEMP2
	rcall ENC_SPI_WRITE_CONTROL_REGISTER_CHECK_TEMP1_TEMP2 	; INP: temp1(cod+addr) temp2(data)				
	ldi temp1,(MAADR2)
	ldi temp2,(MAC2)
	rcall ENC_SPI_WRITE_CONTROL_REGISTER_TEMP1_TEMP2
	rcall ENC_SPI_WRITE_CONTROL_REGISTER_CHECK_TEMP1_TEMP2 	; INP: temp1(cod+addr) temp2(data)				
	ldi temp1,(MAADR3)
	ldi temp2,(MAC3)
	rcall ENC_SPI_WRITE_CONTROL_REGISTER_TEMP1_TEMP2
	rcall ENC_SPI_WRITE_CONTROL_REGISTER_CHECK_TEMP1_TEMP2 	; INP: temp1(cod+addr) temp2(data)				
	ldi temp1,(MAADR4)
	ldi temp2,(MAC4)
	rcall ENC_SPI_WRITE_CONTROL_REGISTER_TEMP1_TEMP2
	rcall ENC_SPI_WRITE_CONTROL_REGISTER_CHECK_TEMP1_TEMP2 	; INP: temp1(cod+addr) temp2(data)				
	ldi temp1,(MAADR5)
	ldi temp2,(MAC5)
	rcall ENC_SPI_WRITE_CONTROL_REGISTER_TEMP1_TEMP2
	rcall ENC_SPI_WRITE_CONTROL_REGISTER_CHECK_TEMP1_TEMP2 	; INP: temp1(cod+addr) temp2(data)				
	ldi temp1,(MAADR6)
	ldi temp2,(MAC6)
	rcall ENC_SPI_WRITE_CONTROL_REGISTER_TEMP1_TEMP2
	rcall ENC_SPI_WRITE_CONTROL_REGISTER_CHECK_TEMP1_TEMP2 	; INP: temp1(cod+addr) temp2(data)				
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ENC_MAC_ADRESSE_CHECK:
	; Vergleich					
	ldi temp1,(MAADR1)
	rcall ENC_SPI_READ_CONTROL_REGISTER_TEMP1
	cpi temp1,(MAC1)
	brne ENC_SPI_MAC_ADRESSE_CHECK_ERROR
	ldi temp1,(MAADR2)
	rcall ENC_SPI_READ_CONTROL_REGISTER_TEMP1
	cpi temp1,(MAC2)
	brne ENC_SPI_MAC_ADRESSE_CHECK_ERROR
	ldi temp1,(MAADR3)
	rcall ENC_SPI_READ_CONTROL_REGISTER_TEMP1
	cpi temp1,(MAC3)
	brne ENC_SPI_MAC_ADRESSE_CHECK_ERROR
	ldi temp1,(MAADR4)
	rcall ENC_SPI_READ_CONTROL_REGISTER_TEMP1
	cpi temp1,(MAC4)
	brne ENC_SPI_MAC_ADRESSE_CHECK_ERROR
	ldi temp1,(MAADR5)
	rcall ENC_SPI_READ_CONTROL_REGISTER_TEMP1
	cpi temp1,(MAC5)
	brne ENC_SPI_MAC_ADRESSE_CHECK_ERROR
	ldi temp1,(MAADR6)
	rcall ENC_SPI_READ_CONTROL_REGISTER_TEMP1
	cpi temp1,(MAC6)
	brne ENC_SPI_MAC_ADRESSE_CHECK_ERROR
	rjmp ENC_SPI_MAC_ADRESSE_CHECK_OK
ENC_SPI_MAC_ADRESSE_CHECK_ERROR:
	ldi temp,(ERROR_ENC_MAC_ADR)
	call ERROR_SAVE_TEMP
ENC_SPI_MAC_ADRESSE_CHECK_OK:
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ENC_EPKTCNT_CHECK:
	ldi temp1,(EPKTCNT)
	rcall ENC_SPI_READ_CONTROL_REGISTER_TEMP1
	tst temp1
	brne ENC_EPKTCNT_FOUND
	ret
ENC_EPKTCNT_FOUND:
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
