; ENC28J60																
; ATmega1284P-16MHz 													
;																		
; AVR-STUDIO 4															
; Bernhard.Erfurt@gmx.de												
; VERSION: 04/2016														
;																		

;																		
; GRN leuchtet: 	alles-ok und alles schn							
; GELB leuchtet:	EPKTCNT > 0											
; GELB2 leuchtet:	ext. Interrupt 										
; ROT  leuchtet: 	Error												
;																		

;																		
; Blinken die LEDs, das ist nicht gut !									
;																		
; ROT+GRN blinkt: 			CLKRDY nicht erkannt (ev. Harwarefehler ?)	
; ROT blinkt: 				Fehler im Programmcheck						
; ROT+GELB blinken: 		WDR-Zeitberschreitung						
; ROT+GELB+GRN blinken: 	unkorrekter Interruptaufruf					
;																		

;												
; Anschlussbelegung PINS						
;												
; PA0 ==> 
; PA1 ==> 
; PA2 ==> 
; PA3 ==> 
; PA4 ==> 
; PA5 ==> 
; PA6 ==> 										
; PA7 ==> 										
;												
; PB0 ==> 
; PB1 ==> 
; PB2 ==> 
; PB3 ==>										
; PB4 ==> 										
; PB5 ==> 										
; PB6 ==> 										
; PB7 ==> 										
;												
; PC0 ==> 										
; PC1 ==> 										
; PC2 ==> 										
; PC3 ==> 
; PC4 ==> 
; PC5 ==> 
; PC6 ==> 
; PC7 ==> 
;												
; PD0 ==> 
; PD1 ==> 
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> 										
; PD6 ==> 										
; PD7 ==> 
;												

; ATmega1284P 									
.include "m1284pdef.inc"
; KONSTANTEN									
.equ TAKT									= 16000000	; 16 MHz		
; USART											
.equ BAUD									= 9600 
; ERROR-CODES									
.equ ERROR_DUMMYx							= 0xFF		; DUMMY					
.equ ERROR_ENC_BFS							= 0x01		; Bit Field Set			
.equ ERROR_ENC_BFC							= 0x02		; Bit Field Clear		
.equ ERROR_ENC_RCR							= 0x03		; Read Control Register	
.equ ERROR_ENC_WCR							= 0x04		; Write Control Register
.equ ERROR_ENC_RBM							= 0x05		; Read Buffer Memory	
.equ ERROR_ENC_WBM							= 0x06		; Write Buffer Memory	
.equ ERROR_ENC_READ_PHY_REGISTER			= 0x07		; READ_PHY_REGISTER		
.equ ERROR_ENC_WRITE_PHY_REGISTER			= 0x08		; WRITE_PHY_REGISTER	
.equ ERROR_CONTROL_REGISTER_CHECK			= 0x0A		; CONTROL-REGISTER-CHECK
.equ ERROR_ENC_MAC_ADR						= 0x0B		; MAC-Adresse			
; MAC-Adresse MAC 00:22:F9:01:BC:27				
.equ MAC1=0x00	 
.equ MAC2=0x22 
.equ MAC3=0xF9 
.equ MAC4=0x01 
.equ MAC5=0xBC 
.equ MAC6=0x27 
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR						= 4
.equ LED_GRUEN_DDR							= DDRA
.equ LED_GRUEN_PORT							= PORTA
; LED-GELB										
.equ LED_GELB_PIN_NR						= 5
.equ LED_GELB_DDR							= DDRA
.equ LED_GELB_PORT							= PORTA
; LED-GELB2										
.equ LED_GELB2_PIN_NR						= 6
.equ LED_GELB2_DDR							= DDRA
.equ LED_GELB2_PORT							= PORTA
; LED-ROT										
.equ LED_ROT_PIN_NR							= 7
.equ LED_ROT_DDR							= DDRA
.equ LED_ROT_PORT							= PORTA
; REGISTER												

.def DUMMY			= R11
.def ERROR_CODE		= R12
.def NULL 			= R14	; ist immer NULL 	
.def EINS 			= R15	; ist immer EINS 	
.def temp 			= R16
.def temp1 			= R17
.def temp2 			= R18
.def temp3 			= R19
.def temp4 			= R20
.def temp5 			= R21
.def temp6 			= R22
.def temp7 			= R23
.def temp8 			= R24
.def temp9 			= R25
; SRAM-BELEGUNG Adr:0x0100-0x40FF(256-16.639=16383)		
.equ adr_DATEN							=SRAM_START+0		

.equ adr_SRAM_CHECK						=SRAM_START+16300		; SRAM CHECK muss immer "S" sein	


;---------------------------------------------------------------------------
.cseg							;Beginn eines Code-Segmentes				
.org 0							;Startadresse=0								
.org 0x0000 rjmp RESET 			 ; Reset									
.org 0x0002 rjmp INTERRUPT_ERROR ;rjmp EXT_INT0 ; IRQ0						
.org 0x0004 rjmp INTERRUPT_ERROR ;rjmp EXT_INT1 ; IRQ1						
.org 0x0006 rjmp EXT_INT2 ; IRQ2											
.org 0x0008 rjmp INTERRUPT_ERROR ;rjmp PCINT0 ; PCINT0						
.org 0x000A rjmp INTERRUPT_ERROR ;rjmp PCINT1 ; PCINT1						
.org 0x000C rjmp INTERRUPT_ERROR ;rjmp PCINT2 ; PCINT2						
.org 0x000E rjmp INTERRUPT_ERROR ;rjmp PCINT3 ; PCINT3						
.org 0x0010 rjmp WDT 		 ; Watchdog Timeout								
.org 0x0012 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPA ; Timer2 CompareA			
.org 0x0014 rjmp INTERRUPT_ERROR ;rjmp TIM2_COMPB ; Timer2 CompareB			
.org 0x0016 rjmp INTERRUPT_ERROR ;rjmp TIM2_OVF 	; Timer2 Overflow		
.org 0x0018 rjmp INTERRUPT_ERROR ;rjmp TIM1_CAPT ; Timer1 Capture			
.org 0x001A rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPA ; Timer1 CompareA				
.org 0x001C rjmp INTERRUPT_ERROR ;rjmp TIM1_COMPB ; Timer1 CompareB			
.org 0x001E rjmp INTERRUPT_ERROR ;TIM1_OVF 	; Timer1 Overflow				
.org 0x0020 rjmp INTERRUPT_ERROR ;TIM0_COMPA ; Timer0 CompareA				
.org 0x0022 rjmp INTERRUPT_ERROR ;rjmp TIM0_COMPB ; Timer0 CompareB			
.org 0x0024 rjmp INTERRUPT_ERROR ;rjmp TIM0_OVF 	; Timer0 Overflow		
.org 0x0026 rjmp INTERRUPT_ERROR ;rjmp SPI_STC ; SPI Transfer Complete		
.org 0x0028 rjmp USART0_RXC ; USART0 RX Complete		
.org 0x002A rjmp INTERRUPT_ERROR ;rjmp USART0_UDRE ; USART0,UDR Empty		
.org 0x002C rjmp INTERRUPT_ERROR ;rjmp USART0_TXC ; USART0 TX Complete		
.org 0x002E rjmp INTERRUPT_ERROR ;rjmp ANA_COMP ; Analog Comparator			
.org 0x0030 rjmp INTERRUPT_ERROR ;rjmp ADC ; ADC Conversion Complete		
.org 0x0032 rjmp INTERRUPT_ERROR ;rjmp EE_RDY ; EEPROM Ready				
.org 0x0034 rjmp INTERRUPT_ERROR ;rjmp TWI ; 2-wire Serial					
.org 0x0036 rjmp INTERRUPT_ERROR ;rjmp SPM_RDY ; SPM Ready					
.org 0x0038 rjmp INTERRUPT_ERROR ;rjmp USART1_RXC ; USART1 RX Complete		
.org 0x003A rjmp INTERRUPT_ERROR ;rjmp USART1_UDRE ; USART1,UDR Empty		
.org 0x003C rjmp INTERRUPT_ERROR ;rjmp USART1_TXC ; USART1 TX Complete		
.org 0x003E rjmp INTERRUPT_ERROR ;rjmp TIM3_CAPT ; Timer3 Capture			
.org 0x0040 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPA ; Timer3 CompareA			
.org 0x0042 rjmp INTERRUPT_ERROR ;rjmp TIM3_COMPB ; Timer3 CompareB			
.org 0x0044 rjmp INTERRUPT_ERROR ;rjmp TIM3_OVF 	; Timer3 Overflow		
; Unkorrekten Interrupt Aufruf 												
INTERRUPT_ERROR:
	WDR
	CLI											; INTERRUPTS sperren	
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus  
	sbi (LED_GELB2_PORT),(LED_GELB2_PIN_NR)		; GELB2aus	
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  aus	
	call wait_100ms
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an   
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_GELB2_PORT),(LED_GELB2_PIN_NR)		; GELB2an	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
	call wait_100ms
rjmp INTERRUPT_ERROR
; Diese Routine wird bei WDR-Zeitberschreitung aufgerufen, hier knnte man		
; sich z.B. den Fehler anzeigen lasen, oder DATEN in den EEPROM schreiben		
WDT:
	WDR
	CLI											; INTERRUPTS sperren	
	sbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN aus	
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus  
	sbi (LED_GELB2_PORT),(LED_GELB2_PIN_NR)		; GELB2aus	
	sbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  aus	
	call wait_100ms
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_GELB2_PORT),(LED_GELB2_PIN_NR)		; GELB2an	
	cbi (LED_ROT_PORT),(LED_ROT_PIN_NR)			; ROT  an	
	call wait_100ms
rjmp WDT
;-------------------------------------------------------------------------------
RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM_CLEAR										
	call SRAM_CLEAR
; PORT_CLEAR										
	call PORT_CLEAR
; REGISTER_CLEAR									
	call REGISTER_CLEAR
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
; WDR_INITIALISIERUNG								
	call WDR_INITIALISIERUNG
; LED_INITIALISIERUNG								
	call LED_INITIALISIERUNG
; LED_TEST											
	call LED_TEST
; USART_INITIALISIERUNG								
	call USART_INITIALISIERUNG
; SPI_INITIALISIERUNG								
	call SPI_INITIALISIERUNG
; EXT_INTERRUPT_INITIALISIERUNG						
	call EXT_INTERRUPT_INITIALISIERUNG
; PROGRAMM_CHECK									
	call PROGRAMM_CHECK
; ENC_INITIALISIERUNG								
	cbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB an	
	call ENC_WAIT_CLKRDY	; wait CLKRDY	
	call ENC_SOFT_RESET		; Reset			
	call WARTUNG_ANZEIGE_TEXT_PROGRAMMSTART
	call WARTUNG_ANZEIGE_ALLE_REGISTER
; ENC_INITIALISIERUNG								
	call WARTUNG_ANZEIGE_TEXT_INITIALISIERUNG
	call ENC_INITIALISIERUNG
; Interrupts freigeben								
	sei
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an   
	sbi (LED_GELB_PORT),(LED_GELB_PIN_NR)		; GELB aus	
	sbi (LED_GELB2_PORT),(LED_GELB2_PIN_NR)		; GELB2 aus	
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR												; Watch-Dog-RESET	
	call WARTUNG_ANZEIGE_ALLE_REGISTER

	ldi temp9,255
LOOP_s:
	push temp9
	call PROGRAMM_CHECK
	call ENC_MAC_ADRESSE_CHECK	
	call ENC_EPKTCNT_CHECK
	pop temp9
	call WAIT_10ms
	dec temp9
	brne LOOP_s
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "NETIO_ENC28J60_DEF.asm"		; ENC28J60 Definitionen			
.include "NETIO_ENC_INITIALISIERUNG.asm"; ENC-INITIALISIERUNG			
.include "NETIO_ENC_SONSTIGES.asm"		; ENC28J60						
.include "NETIO_ENC_SPI.asm"			; ENC-SPI						
.include "NETIO_SPI.asm"				; SPI							
.include "NETIO_USART.asm"				; USART							
.include "NETIO_EXT_INTERRUPT.asm"		; ext. Interupt					
.include "NETIO_WARTUNG.asm"			; Wartung						
.include "NETIO_SONSTIGES.asm"			; sonstiges						
.include "NETIO_WAIT_16MHZ.asm"			; WAIT							
; ##############################################################################
; ##############################################################################
; ##############################################################################
